## ros-r2b3-intra-process-demo 0.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(intra_process_demo)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rmw REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)

find_package(OpenCV REQUIRED)

include_directories(include)
ament_export_include_directories(include)

##
## Demos
##

# Simple example of using unique_ptr to minimize copies.
add_executable(two_node_pipeline
  src/two_node_pipeline/two_node_pipeline.cpp)
ament_target_dependencies(two_node_pipeline
  "rclcpp"
  "std_msgs")

  # Simple example of a cyclic pipeline which uses no allocation while iterating.
add_executable(cyclic_pipeline
  src/cyclic_pipeline/cyclic_pipeline.cpp)
ament_target_dependencies(cyclic_pipeline
  "rclcpp"
  "std_msgs")

# A single program with one of each of the image pipeline demo nodes.
add_executable(image_pipeline_all_in_one
  src/image_pipeline/image_pipeline_all_in_one.cpp)
ament_target_dependencies(image_pipeline_all_in_one
  "rclcpp"
  "sensor_msgs"
  "OpenCV")

# A single program with one of each of the image pipeline demo nodes, but two image views.
add_executable(image_pipeline_with_two_image_view
  src/image_pipeline/image_pipeline_with_two_image_view.cpp)
ament_target_dependencies(image_pipeline_with_two_image_view
  "rclcpp"
  "sensor_msgs"
  "OpenCV")

# A stand alone node which produces images from a camera using OpenCV.
add_executable(camera_node
  src/image_pipeline/camera_node.cpp)
ament_target_dependencies(camera_node
  "rclcpp"
  "sensor_msgs"
  "OpenCV")

# A stand alone node which adds some text to an image using OpenCV before passing it along.
add_executable(watermark_node
  src/image_pipeline/watermark_node.cpp)
ament_target_dependencies(watermark_node
  "rclcpp"
  "sensor_msgs"
  "OpenCV")

# A stand alone node which consumes images and displays them using OpenCV.
add_executable(image_view_node
  src/image_pipeline/image_view_node.cpp)
ament_target_dependencies(image_view_node
  "rclcpp"
  "sensor_msgs"
  "OpenCV")

install(TARGETS
  two_node_pipeline
  cyclic_pipeline
  image_pipeline_all_in_one
  image_pipeline_with_two_image_view
  camera_node
  watermark_node
  image_view_node
  DESTINATION lib/${PROJECT_NAME})

install(
  DIRECTORY include/
  DESTINATION include
)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(rmw_implementation_cmake REQUIRED)

  # Add each test case.  Multi-executable tests can be specified in
  # semicolon-separated strings, like  exe1:exe2.
  set(demo_tests
    cyclic_pipeline
    two_node_pipeline)

  macro(tests)
    foreach(demo_test ${demo_tests})
      string(REPLACE ":" ";" demo_executables "${demo_test}")
      set(RCLCPP_DEMOS_EXPECTED_OUTPUT "")
      foreach(executable ${demo_executables})
        list(APPEND RCLCPP_DEMOS_EXPECTED_OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/test/${executable}")
      endforeach()

      set(RCLCPP_DEMOS_EXECUTABLE "")
      foreach(executable ${demo_executables})
        list(APPEND RCLCPP_DEMOS_EXECUTABLE "$<TARGET_FILE:${executable}>")
      endforeach()

      string(REPLACE ";" "_" exe_list_underscore "${demo_executables}")
      configure_file(
        test/test_executables_demo.py.in
        test_${exe_list_underscore}${target_suffix}.py.configured
        @ONLY
      )
      file(GENERATE
        OUTPUT "test_${exe_list_underscore}${target_suffix}_$<CONFIG>.py"
        INPUT "${CMAKE_CURRENT_BINARY_DIR}/test_${exe_list_underscore}${target_suffix}.py.configured"
      )

      ament_add_nose_test(test_demo_${exe_list_underscore}${target_suffix}
        "${CMAKE_CURRENT_BINARY_DIR}/test_${exe_list_underscore}${target_suffix}_$<CONFIG>.py"
        TIMEOUT 30
        ENV
        RCL_ASSERT_RMW_ID_MATCHES=${rmw_implementation}
        RMW_IMPLEMENTATION=${rmw_implementation})
      set_tests_properties(test_demo_${exe_list_underscore}${target_suffix}
        PROPERTIES DEPENDS "test_demo_${exe_list_underscore}${target_suffix} test_demo_${exe_list_underscore}${target_suffix}")
    endforeach()
  endmacro()

  call_for_each_rmw_implementation(tests)
endif()

ament_package()

=== debian/changelog ===
ros-r2b3-intra-process-demo (0.0.3-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- William Woodall <william@osrfoundation.org>  Wed, 13 Sep 2017 23:21:47 -0000

=== debian/control ===
Source: ros-r2b3-intra-process-demo
Section: misc
Priority: extra
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), libopencv-dev, ros-r2b3-ament-cmake, ros-r2b3-ament-cmake-nose, ros-r2b3-ament-lint-auto, ros-r2b3-ament-lint-common, ros-r2b3-launch, ros-r2b3-launch-testing, ros-r2b3-rclcpp, ros-r2b3-rmw-implementation-cmake, ros-r2b3-sensor-msgs, ros-r2b3-std-msgs, ros-r2b3-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-r2b3-intra-process-demo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopencv-dev, ros-r2b3-rclcpp, ros-r2b3-sensor-msgs, ros-r2b3-ros-workspace
Description: Demonstrations of intra process communication.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/r2b3/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b3/setup.sh" ]; then . "/opt/ros/r2b3/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/r2b3" \
		-DAMENT_PREFIX_PATH="/opt/ros/r2b3"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b3/setup.sh" ]; then . "/opt/ros/r2b3/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/r2b3/setup.sh" ]; then . "/opt/ros/r2b3/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b3/setup.sh" ]; then . "/opt/ros/r2b3/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-r2b3-intra-process-demo//opt/ros/r2b3/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b3/setup.sh" ]; then . "/opt/ros/r2b3/setup.sh"; fi && \
	dh_auto_install
